_G[gTable] = {};

local aTmpVal = gTable;
cm.SetupTable(_G[aTmpVal]);


-- Called on Init
_G[gTable].OnInit = function(pObj)
	pObj.mState = 0;
end

-- Called after data being loaded from disk
_G[gTable].OnLoad = function(pObj)

end


-- Called on a update
_G[gTable].OnUpdate = function(pObj)

	if pObj.mState == 1 then
      if  not pObj.mAlpha:AncIsChanging() then
      	local aImg = IcImageWrap(pObj.mSmallImage);
       	local aNumCells = aImg:GetNumCells();

       	if pObj.mCurCell < aNumCells - 1 then
	         pObj:StartFadeRects(PhFadeAnotherTimeShort);
	         pObj:StopParticleEmission(false);
	         pObj.mCurCell = pObj.mCurCell + 1;
			else
			   pObj.mState = pObj.mState + 1;
			   cm.SetGlobalValIndirect(pObj, "SetFlag1", true);
			end
		end
	end

end


-- Called on a succesful click
_G[gTable].OnClick =  function(pObj, pName, pActorObj, pPolyNum, pX, pY)

	pObj.mDiscovered = true;
	if not cm.GetGlobalBoolIndirect(pObj, "ActivatorFlag1") then
      if pName == "" then
         cm.GetShowInfo(pObj, "InfoStr1", "InfoTime1");
         IcPlaySample("PH_SFX_DOES_NOT_WORK");
         return true;
      else
   		cm.ObjDoesNotWork(pObj);
   		pObj.mPdata:UnMouseObject();
   		return true;
   	end
   end

	if pName == "" then

      cm.GetShowInfo(pObj, "InfoStr2", "InfoTime2");
      pObj:StartFadeRects(PhFadeAnotherTimeShort);
		pObj.mState     = pObj.mState + 1;
		pObj.mCurCell	 = pObj.mCurCell + 1;
		cm.DisableObject(pObj);
		IcPlaySample("PH_SFX_STONESLABSLIDES");
		return true;

	else
		cm.ObjDoesNotWork(pObj);
		return false;
	end

	return false;

end


-- Called on draw
_G[gTable].OnDraw =  function(pObj, pG)

	local aImg  = IcImageWrap(pObj.mSmallImage);
	assert(aImg);
	local aRpos = pObj.mSmPos;
	local aRect = aImg:GetCelRect(pObj.mCurCell);

	if (pObj.mState == 2) then
		pG:SetColorizeImages(true);
		pG:SetColor(Color(255, 255, 255, pObj.mAlpha:AncGetVal()));
	end
	pG:DrawImage(aImg:GetImage(), aRpos.x, aRpos.y, aRect);

end



